# $Header: /fridge/cvs/libjcgi/libjcgi.m4,v 1.4 2002/06/21 05:33:49 justins Exp $
# Hacked from configure for GLIB
# Hacked by Justin David Smith, 2001.12.10
# Owen Taylor     97-11-3


dnl AM_PATH_LIBJCGI([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for LIBJCGI, and define LIBJCGI_CFLAGS and LIBJCGI_LIBS, if "gmodule" or 
dnl gthread is specified in MODULES, pass to libjcgi-config
dnl
AC_DEFUN(AM_PATH_LIBJCGI,
[dnl 
dnl Get the cflags and libraries from the libjcgi-config script
dnl
AM_PATH_LIBJ(4.0.6, , 
 [ echo "*** Could not find a suitable version of libj. Cannot use libjcgi."
   LIBJCGI_CFLAGS=""
   LIBJCGI_LIBS=""
   LIBJCGI_VERSION=""
   ifelse([$3], , :, [$3])
 ])
AC_ARG_WITH(libjcgi-prefix,[  --with-libjcgi-prefix=PFX   Prefix where LIBJCGI is installed (optional)],
            libjcgi_config_prefix="$withval", libjcgi_config_prefix="")
AC_ARG_WITH(libjcgi-exec-prefix,[  --with-libjcgi-exec-prefix=PFX Exec prefix where LIBJCGI is installed (optional)],
            libjcgi_config_exec_prefix="$withval", libjcgi_config_exec_prefix="")
AC_ARG_ENABLE(libjcgitest, [  --disable-libjcgitest       Do not try to compile and run a test LIBJCGI program],
                    , enable_libjcgitest=yes)

  if test x$libjcgi_config_exec_prefix != x ; then
     libjcgi_config_args="$libjcgi_config_args --exec-prefix=$libjcgi_config_exec_prefix"
     if test x${LIBJCGI_CONFIG+set} != xset ; then
        LIBJCGI_CONFIG=$libjcgi_config_exec_prefix/bin/libjcgi-config
     fi
  fi
  if test x$libjcgi_config_prefix != x ; then
     libjcgi_config_args="$libjcgi_config_args --prefix=$libjcgi_config_prefix"
     if test x${LIBJCGI_CONFIG+set} != xset ; then
        LIBJCGI_CONFIG=$libjcgi_config_prefix/bin/libjcgi-config
     fi
  fi

  for module in . $4
  do
      case "$module" in
         gmodule) 
             libjcgi_config_args="$libjcgi_config_args gmodule"
         ;;
         gthread) 
             libjcgi_config_args="$libjcgi_config_args gthread"
         ;;
      esac
  done

  AC_PATH_PROG(LIBJCGI_CONFIG, libjcgi-config, no)
  min_libjcgi_version=ifelse([$1], ,0.99.7,$1)
  AC_MSG_CHECKING(for LIBJCGI - version >= $min_libjcgi_version)
  no_libjcgi=""
  if test "$LIBJCGI_CONFIG" = "no" ; then
    no_libjcgi=yes
  else
    LIBJCGI_CFLAGS=`$LIBJCGI_CONFIG $libjcgi_config_args --cflags`
    LIBJCGI_LIBS=`$LIBJCGI_CONFIG $libjcgi_config_args --libs`
    LIBJCGI_VERSION=`$LIBJCGI_CONFIG $libjcgi_config_args --version`
    libjcgi_config_major_version=`$LIBJCGI_CONFIG $libjcgi_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    libjcgi_config_minor_version=`$LIBJCGI_CONFIG $libjcgi_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    libjcgi_config_micro_version=`$LIBJCGI_CONFIG $libjcgi_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_libjcgitest" = "xyes" ; then
      ac_save_CFLAGS="$CFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $LIBJCGI_CFLAGS"
      LIBS="$LIBJCGI_LIBS $LIBS"
dnl
dnl Now check if the installed LIBJCGI is sufficiently new. (Also sanity
dnl checks the results of libjcgi-config to some extent
dnl
      rm -f conf.libjcgitest
      AC_TRY_RUN([
#define  ALLOW_LIBC_STRING    1
#include <string.h>
#include <libjcgi.h>
#include <stdio.h>
#include <stdlib.h>

int 
main ()
{
  int major, minor, micro;
  unsigned int libjcgi_v;
  unsigned int libjcgi_major_version;
  unsigned int libjcgi_minor_version;
  unsigned int libjcgi_micro_version;
  unsigned int LIBJCGI_MAJOR_VERSION;
  unsigned int LIBJCGI_MINOR_VERSION;
  unsigned int LIBJCGI_MICRO_VERSION;
  char *tmp_version;

  system ("touch conf.libjcgitest");

  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = strdup("$min_libjcgi_version");
  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
     printf("%s, bad version string\n", "$min_libjcgi_version");
     exit(1);
   }
   
  libjcgi_v = libjcgi_version();
  libjcgi_major_version = (libjcgi_v >> 24) & 0xff;
  libjcgi_minor_version = (libjcgi_v >> 16) & 0xff;
  libjcgi_micro_version = (libjcgi_v >> 8)  & 0xff;
  LIBJCGI_MAJOR_VERSION = (__libjcgi_version >> 24) & 0xff;
  LIBJCGI_MINOR_VERSION = (__libjcgi_version >> 16) & 0xff;
  LIBJCGI_MICRO_VERSION = (__libjcgi_version >> 8)  & 0xff;

  if ((libjcgi_major_version != $libjcgi_config_major_version) ||
      (libjcgi_minor_version != $libjcgi_config_minor_version) ||
      (libjcgi_micro_version != $libjcgi_config_micro_version))
    {
      printf("\n*** 'libjcgi-config --version' returned %d.%d.%d, but LIBJCGI (%d.%d.%d)\n", 
             $libjcgi_config_major_version, $libjcgi_config_minor_version, $libjcgi_config_micro_version,
             libjcgi_major_version, libjcgi_minor_version, libjcgi_micro_version);
      printf ("*** was found! If libjcgi-config was correct, then it is best\n");
      printf ("*** to remove the old version of LIBJCGI. You may also be able to fix the error\n");
      printf("*** by modifying your LD_LIBRARY_PATH enviroment variable, or by editing\n");
      printf("*** /etc/ld.so.conf. Make sure you have run ldconfig if that is\n");
      printf("*** required on your system.\n");
      printf("*** If libjcgi-config was wrong, set the environment variable LIBJCGI_CONFIG\n");
      printf("*** to point to the correct copy of libjcgi-config, and remove the file config.cache\n");
      printf("*** before re-running configure\n");
    } 
  else if ((libjcgi_major_version != LIBJCGI_MAJOR_VERSION) ||
           (libjcgi_minor_version != LIBJCGI_MINOR_VERSION) ||
           (libjcgi_micro_version != LIBJCGI_MICRO_VERSION))
    {
      printf("*** LIBJCGI header files (version %d.%d.%d) do not match\n",
             LIBJCGI_MAJOR_VERSION, LIBJCGI_MINOR_VERSION, LIBJCGI_MICRO_VERSION);
      printf("*** library (version %d.%d.%d)\n",
             libjcgi_major_version, libjcgi_minor_version, libjcgi_micro_version);
    }
  else
    {
      if ((libjcgi_major_version > major) ||
        ((libjcgi_major_version == major) && (libjcgi_minor_version > minor)) ||
        ((libjcgi_major_version == major) && (libjcgi_minor_version == minor) && (libjcgi_micro_version >= micro)))
      {
        return 0;
       }
     else
      {
        printf("\n*** An old version of LIBJCGI (%d.%d.%d) was found.\n",
               libjcgi_major_version, libjcgi_minor_version, libjcgi_micro_version);
        printf("*** You need a version of LIBJCGI newer than %d.%d.%d. The latest version of\n",
               major, minor, micro);
        printf("*** LIBJCGI is always available from http://chaos2.org./.\n");
        printf("***\n");
        printf("*** If you have already installed a sufficiently new version, this error\n");
        printf("*** probably means that the wrong copy of the libjcgi-config shell script is\n");
        printf("*** being found. The easiest way to fix this is to remove the old version\n");
        printf("*** of LIBJCGI, but you can also set the LIBJCGI_CONFIG environment to point to the\n");
        printf("*** correct copy of libjcgi-config. (In this case, you will have to\n");
        printf("*** modify your LD_LIBRARY_PATH enviroment variable, or edit /etc/ld.so.conf\n");
        printf("*** so that the correct libraries are found at run-time))\n");
      }
    }
  return 1;
}
],, no_libjcgi=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_libjcgi" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$LIBJCGI_CONFIG" = "no" ; then
       echo "*** The libjcgi-config script installed by LIBJCGI could not be found"
       echo "*** If LIBJCGI was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the LIBJCGI_CONFIG environment variable to the"
       echo "*** full path to libjcgi-config."
     else
       if test -f conf.libjcgitest ; then
        :
       else
          echo "*** Could not run LIBJCGI test program, checking why..."
          CFLAGS="$CFLAGS $LIBJCGI_CFLAGS"
          LIBS="$LIBS $LIBJCGI_LIBS"
          AC_TRY_LINK([
#include <libjcgi.h>
#include <stdio.h>
],      [ return (__libjcgi_version == 0); ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding LIBJCGI or finding the wrong"
          echo "*** version of LIBJCGI. If it is not finding LIBJCGI, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
          echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH" ],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means LIBJCGI was incorrectly installed"
          echo "*** or that you have moved LIBJCGI since it was installed. In the latter case, you"
          echo "*** may want to edit the libjcgi-config script: $LIBJCGI_CONFIG" ])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     LIBJCGI_CFLAGS=""
     LIBJCGI_LIBS=""
     LIBJCGI_VERSION=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(LIBJCGI_CFLAGS)
  AC_SUBST(LIBJCGI_LIBS)
  AC_SUBST(LIBJCGI_VERSION)
  rm -f conf.libjcgitest
])
